import requests


def testurl(proxy, url):
    if proxy.isworking:
        r = proxy.session.get(url)
        data = r.text
        print(data)


def test(proxy):

    # print(f'http://{proxy.usr}:{proxy.pwd}@{proxy.url}:{proxy.port}')

    proxy.session = requests.Session()
    url = "https://api.ipify.org/"

    proxies = {
        'http': f'http://{proxy.usr}:{proxy.pwd}@{proxy.url}:{proxy.port}',
        'https': f'http://{proxy.usr}:{proxy.pwd}@{proxy.url}:{proxy.port}'
    }

    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko)'
                      ' Chrome/86.0.4240.111 Safari/537.36'
    }

    try:
        proxy.session.headers = headers

        # Check incoming ip
        r = proxy.session.get(url)
        incoming = r.text

        # Check proxied ip
        proxy.session.proxies = proxies
        r = proxy.session.get(url)

        if r.status_code == 200:
            proxy.ip = r.text
            print(f"Proxied {incoming} to {proxy.ip}")
            proxy.isworking = True
        else:
            print(r.text)
            proxy.isworking = False

        print(f"Statuscode: {r.status_code}\nGood Proxy: {proxy.isworking}")

    except Exception as e:
        print(f"Connection Error! (check Proxy settings)\n\n{e}")
        proxy.isworking = False


class Proxy:

    def __init__(self):

        self.name = None
        self.url = None
        self.port = None
        self.usr = None
        self.pwd = None
        self.ip = None
        self.session = None
        self.isworking = None
